欧拉图
本页面将简要介绍欧拉图的概念、实现和应用。
定义
- 欧拉回路:通过图中每条边恰好一次的回路
- 欧拉通路:通过图中每条边恰好一次的通路
- 欧拉图:具有欧拉回路的图
- 半欧拉图:具有欧拉通路但不具有欧拉回路的图
性质
欧拉图中所有顶点的度数都是偶数。
若
是欧拉图,则它为若干个环的并,且每条边被包含在奇数个环内。
判别法
- 无向图是欧拉图当且仅当:
- 无向图是半欧拉图当且仅当:
- 有向图是欧拉图当且仅当:
- 有向图是半欧拉图当且仅当:
- 非零度顶点是弱连通的
- 至多一个顶点的出度与入度之差为 1
- 至多一个顶点的入度与出度之差为 1
- 其他顶点的入度和出度相等
求欧拉回路或欧拉路
Fleury 算法
也称避桥法,是一个偏暴力的算法。
算法流程为每次选择下一条边的时候优先选择不是桥的边。
一个广泛使用但是错误的实现方式是先 Tarjan 预处理桥边,然后再 DFS 避免走桥。但是由于走图过程中边会被删去,一些非桥边会变为桥边导致错误。最简单的实现方法是每次删除一条边之后暴力跑一遍 Tarjan 找桥,时间复杂度是
。复杂的实现方法要用到动态图等,实用价值不高。
Hierholzer 算法
也称逐步插入回路法。
过程
算法流程为从一条回路开始,每次任取一条目前回路中的点,将其替换为一条简单回路,以此寻找到一条欧拉回路。如果从路开始的话,就可以寻找到一条欧拉路。
实现
Hierholzer 算法的暴力实现如下:

性质
这个算法的时间复杂度约为
。实际上还有复杂度更低的实现方法,就是将找回路的 DFS 和 Hierholzer 算法的递归合并,边找回路边使用 Hierholzer 算法。
如果需要输出字典序最小的欧拉路或欧拉回路的话,因为需要将边排序,时间复杂度是
(计数排序或者基数排序可以优化至
)。如果不需要排序,时间复杂度是
。
应用
有向欧拉图可用于计算机译码。
设有
个字母,希望构造一个有
个扇形的圆盘,每个圆盘上放一个字母,使得圆盘上每连续
位对应长为
的符号串。转动一周(
次)后得到由
个字母产生的长度为
的
个各不相同的符号串。

构造如下有向欧拉图:
设
,构造
,如下:


规定
中顶点与边的关联关系如下:
顶点
引出
条边:
。
边
引入顶点
。

这样的
是连通的,且每个顶点入度等于出度(均等于
),所以
是有向欧拉图。
任求
中一条欧拉回路
,取
中各边的最后一个字母,按各边在
中的顺序排成圆形放在圆盘上即可。
例题
洛谷 P2731 骑马修栅栏
给定一张有 500 个顶点的无向图,求这张图的一条欧拉路或欧拉回路。如果有多组解,输出最小的那一组。
在本题中,欧拉路或欧拉回路不需要经过所有顶点。
边的数量 m 满足
。
解题思路
用 Fleury 算法解决本题的时候只需要再贪心就好,不过由于复杂度不对,还是换 Hierholzer 算法吧。
保存答案可以使用 stack<int>,因为如果找的不是回路的话必须将那一部分放在最后。
注意,不能使用邻接矩阵存图,否则时间复杂度会退化为
。由于需要将边排序,建议使用前向星或者 vector 存图。示例代码使用 vector。
示例代码
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82 | #include <algorithm>
#include <cstdio>
#include <stack>
#include <vector>
using namespace std;
struct edge {
int to;
bool exists;
int revref;
bool operator<(const edge& b) const { return to < b.to; }
};
vector<edge> beg[505];
int cnt[505];
const int dn = 500;
stack<int> ans;
void Hierholzer(int x) { // 关键函数
for (int& i = cnt[x]; i < (int)beg[x].size();) {
if (beg[x][i].exists) {
edge e = beg[x][i];
beg[x][i].exists = 0;
beg[e.to][e.revref].exists = 0;
++i;
Hierholzer(e.to);
} else {
++i;
}
}
ans.push(x);
}
int deg[505];
int reftop[505];
int main() {
for (int i = 1; i <= dn; ++i) {
beg[i].reserve(1050); // vector 用 reserve 避免动态分配空间,加快速度
}
int m;
scanf("%d", &m);
for (int i = 1; i <= m; ++i) {
int a, b;
scanf("%d%d", &a, &b);
beg[a].push_back((edge){b, 1, 0});
beg[b].push_back((edge){a, 1, 0});
++deg[a];
++deg[b];
}
for (int i = 1; i <= dn; ++i) {
if (!beg[i].empty()) {
sort(beg[i].begin(), beg[i].end()); // 为了要按字典序贪心,必须排序
}
}
for (int i = 1; i <= dn; ++i) {
for (int j = 0; j < (int)beg[i].size(); ++j) {
beg[i][j].revref = reftop[beg[i][j].to]++;
}
}
int bv = 0;
for (int i = 1; i <= dn; ++i) {
if (!deg[bv] && deg[i]) {
bv = i;
} else if (!(deg[bv] & 1) && (deg[i] & 1)) {
bv = i;
}
}
Hierholzer(bv);
while (!ans.empty()) {
printf("%d\n", ans.top());
ans.pop();
}
}
|
习题